#include "ti86asm.inc"


.org _asm_exec_ram


_temp       = $8800
_temp2      = _textShadow

sankta_vanster  = _temp + 0     ;1 - Antalet snkta skepp p vnster sida
sankta_hoger    = _temp + 1     ;1
insatta_skepp   = _temp + 2     ;1 - Hur mnga skepp som blivit insatta
vilken_sida     = _temp + 3     ;1 - 1 om vnster r aktiv, annars 2
kursor          = _temp + 4     ;2 - Kursorns position
andra_kursorn   = _temp + 6     ;2 - Kursorn p det brde som inte r akrivt
skall_satta_in  = _temp + 8     ;1 - Hur mnga bitar det finns i skeppet som stts in just d
har_satt_in     = _temp + 9     ;1 - Hur mnga bitar som blivit utsatta i skeppet
text_kursor     = _temp + 10    ;2 - Var textkursorn skall vara
brade_1         = _temp + 12    ;210 - Matris med statisktik fr alla rutor p planen + mellanrummet mellan planerna

;i brde_1:
;   bit 6: 1=skepp 0=tom
;   bit 7: 1=gra 0=tom
;   resten: nummer som anger hur mnte skeppet det r om det r ett skepp


    call _clrScrn
    call _runindicoff
    call _flushallmenus

;brjar p vnster sida
    ld bc,1+(256*12)
    ld (andra_kursorn),bc

    xor a
    ld (brade_1),a  ;a r redan 0
    ld hl,brade_1
    ld de,brade_1+1
    ld bc,210
    ldir            ;skriver "0" till alla rutor

    ld hl,_temp
    ld (hl),a       ;sankta_vanster
    inc hl

    ld (hl),a       ;sankta hoger
    inc hl

    ld (hl),a       ;insatta_skepp
    inc hl

    ld d,a          ;sparar undan
    inc a

    ld (hl),a       ;vilken_sida
    inc hl

    ld (hl),a       ;kursor
    inc hl          ;
    ld (hl),a       ;



;   ld d,0              ;x variabeln fr frsta rutsystemt
    call visa_rutorna   ;ritar upp ett 10*10 rutsystem med brjan vid (d,0)
    call visa_kursor    ;ritar ut kursorn vid (kursor)

    ld hl,56*256+6
    ld (_penCol),hl
    ld hl,add_t
    call _vputs
    ld hl,(_penCol)
    ld (text_kursor),hl ;stller in textkursorn

satt_in_nasta:
;brjar p nytt skepp
    xor a
    ld (har_satt_in),a
    ld b,a      ;b skall vara noll lite lngre fram

;kollar om man satt in alla skeppen (nolla i skepp_att_satta_in listan)
    ld hl,skepp_att_satta_in
    ld a,(insatta_skepp)
    ld c,a
    add hl,bc       ;b r redan 0
    ld a,(hl)
    cp 0
    jr z,fardig     ;byter sida eller brjar skjuta
    ld (skall_satta_in),a   ;spara hur mnga bitar nsta skepp innehller

;visar hur mnga rutor skeppet skall innehlla
    ld b,'0'        ;fr att ge rtt siffra till _vputmap
    add a,b

    ld bc,(text_kursor)     ;varierar beroende p vilken sida som r aktiv
    ld (_penCol),bc
    call _vputmap

;hjer insatta_skepp
    ld hl,insatta_skepp     
    inc (hl)


key_loop:
    call _getkey
    cp kLeft
    call z,left
    cp kRight
    call z,right
    cp kUp
    call z,up
    cp kDown
    call z,down

    cp kEnter
    jp z,lagg_in

    cp kExit
    jr z,sluta      ;slutar om man tryckte Exit


;frsker igen om man inte tryckte pil, exit eller enter
    jp key_loop


;byter sida eller brjar skjuta 
fardig:
;brjar skjuta om man bda sidorna r fixade (vilken_sida=2)
    ld a,(vilken_sida)
    cp 2
    jr z,borja_skuta



;hoppar ver nollan i listan
    ld hl,insatta_skepp
    inc (hl)
;vilken_sida=2
    inc hl      ;vilken_sida
    inc (hl)    ;var 1 tidigare eftersom programmet kom hit
;nytt rutmnster p andra sidan
    call _clrLCD
    ld d,11
    call visa_rutorna
    
;flyttar kursorn
    ld hl,56*256+61
    ld (_penCol),hl
    ld hl,add_t
    call _vputs
    ld hl,(_penCol)
    ld (text_kursor),hl ;stller in textkursorn    

;flyttar kursorn
    call byt_kursor     ;byter kursor och andra_kursorn
    call visa_kursor

    jr satt_in_nasta    ;brjar stta in igen.
    

;avslutar
sluta:
    call _clrScrn
    ret

;byter kursor och andra_kursorn
byt_kursor:
    ld hl,(kursor)
    ld de,(andra_kursorn)
    ld (kursor),de
    ld (andra_kursorn),hl
    ret

;stller in vissa saker infr skyttet
borja_skuta:
    call _clrScrn

;brjar p vnster sida
    ld hl,vilken_sida
    dec (hl)        ;vilken_sida var 2 frn frra steget

;nollstller kursorn s att man inte skall se ver det senaste skeppet blev insatt
    ld bc,1+(256*12)
    ld (andra_kursorn),bc

    ld bc,1+(256*1)
    ld (kursor),bc

;ritar rutsystemet p bda sidorna
    ld d,0
    call visa_rutorna
    ld d,11
    call visa_rutorna   

;trollar fram kursorn
    call visa_kursor

;tar bort upptagna-markeringarna
    ld b,210
    ld hl,brade_1
nollstall_loop:
    res 7,(hl)
    inc hl
    djnz nollstall_loop


skuta_getkey:
    call _getkey
    cp kLeft
    call z,left
    cp kRight
    call z,right
    cp kUp
    call z,up
    cp kDown
    call z,down

    cp kEnter
    jp z,skjut

    cp kExit
    jr z,sluta      ;slutar om man tryckte Exit

;loopar
    jp skuta_getkey

skjut:
;kollar var man trffar
    ld bc,(kursor)
    call get_info       ;hl pekar p rutan som bc r vid
    
;frsk igen om man siktade p en ppnad ruta
    bit 7,(hl)
    jp nz,skuta_getkey
;kollar om man trffade ett skepp
    bit 6,(hl)
    jp nz,skepp_traff

;fortstter hr om man missade
;stter att rutan r ppnad 
    set 7,(hl)
;visar gra_sprite
    ld hl,gra_sprite
    call visa_sprite

    jp byt_sida

;ndrar det som skall ndras d det blir den andra spelarens tur
byt_sida:
;tar bort gamla kursorn
    ld bc,(kursor)
    ld hl,tom_sprite
    call visa_sprite

;stter ut kursorn p anda sidan
    call byt_kursor
    call visa_kursor

;vilken_sida byter vrde (1<->2)
    ld a,(vilken_sida)
    ld b,a
    ld a,3
    sub b
    ld (vilken_sida),a

;forstter
    jp skuta_getkey


;om man trffade en skeppbit
skepp_traff:
;stller in att rutan r ppnad
    set 7,(hl)
;rutar ut en skeppsbit
    push hl
    ld hl,skepp_sprite
    call visa_sprite
    pop hl

;kollar hur mnga av det skeppet som redan r ppnade
    ld a,(hl)       ;a=skeppets nummer och masken fr ppnad
    ld hl,brade_1
    ld b,210        ;210 bitar att kolla
    ld d,0          ;counter
hur_manga_traffade_loop:
    cp (hl) 
    jp nz,inte_denna
    inc d
inte_denna:
    inc hl
    djnz hur_manga_traffade_loop

;ser hur mnga master det trffade skeppet har
    and %00111111   ;a=skeppets nummer (utan mask)
    ld c,a
;   ld b,0          ;b=0 efter djnz
    ld hl,skepp_att_satta_in-1
    add hl,bc
    
    ld a,(hl)       ;a=hur mnga master skeppet har
    cp d            ;d=hur mnga av skeppets master som r hittade
    jp nz,skuta_getkey ;fr skjuta igen eftersom man har trffat

;fortstter om man snkte skeppet
;skeppets nummer-1
    ld a,c          ;skeppets nummer

    call markera_runt   ;gr alla rutor runt alla delar av skeppet nr. a gra

;kollar om man skt alla skepp
    ld a,(vilken_sida)

    ld b,0
    ld c,a
    ld hl,sankta_vanster-1
    add hl,bc           ;om vilken_sida = 1 pekar hl p sankta_vanster, om vilken_sida = 3 pekar hl p sankta_hoger

    inc (hl)            ;kar antalet snkta fr den sidan
    ld a,(hl)           ;kolla hur mnga det r

    ld hl,skepp_att_sanka
    cp (hl)             ;jmfr med hur mnga det finns att snka
    jp z,spelet_slut    ;avslutar om man snkt alla

;annars fr man skjuta igen
    jp skuta_getkey

;avslutar spelet d ngon vunnit
;visar var alla skepp fanns
spelet_slut:
;inverterar skepp_sprite, 4 bytes kortare n att ha det som en skild sprite
    ld hl,skepp_sprite
    ld b,5
andra_spriten_loop:
    ld a,(hl)
    xor %01111000
    ld (hl),a
    inc hl
    djnz andra_spriten_loop


    ld hl,brade_1
    ld b,210
visa_alla_loop:
    push bc
    push hl
;spriten skall inte sttas p rutor dr det inte fanns ett skepp
    bit 6,(hl)
    jp z,visa_alla_slut
;spriten skall inte sttas p hittade skepp
    bit 7,(hl)
    jp nz,visa_alla_slut

;visar spriten p alla andra rutor
    push hl
    call get_info_bak
    ld hl,skepp_sprite
    call visa_sprite
    pop hl

visa_alla_slut:
    pop hl
    inc hl      ;nsta ruta
    pop bc
    djnz visa_alla_loop

    call _getkey
    call _clrScrn
    ret

;gr alla rutor runt skepp nr. a gra
markera_runt:
;kollar hur mnga rutor skeppet har -> b
    ld hl,skepp_att_satta_in-1
    ld b,0
    ld c,a
    add hl,bc
    ld a,(hl)
    ld b,a

    ld hl,brade_1-1     ;brjar ett fr tidigt eftersom loopen mste brja med "inc hl"
markera_runt_loop:
    push bc

;sker rutor med nr c
sok_skeppbit_loop:
    inc hl
    ld a,(hl)
    and %00111111       ;tar bort masken
    cp c                ;skeppets nummer

    jp nz,sok_skeppbit_loop     ;provar med nsta om det inte var den rutan
    
    call get_info_bak           ;ger kordinaterna fr rutan som hl pekar p

    push hl
;upp, vnster
    dec b
    dec c
    call analysera      ;gr rutan gr om det inte r en del av ett skepp
;upp, mitten
    inc b
    call analysera

;upp,hger
    inc b
    call analysera
;mitten,hger   
    inc c
    call analysera
;ner,hger
    inc c
    call analysera
;ner,mitten
    dec b
    call analysera
;ner,vnster
    dec b
    call analysera
;mitten,vnster
    dec c
    call analysera
    pop hl

;det finns (kanske) flera delar av skeppet
    pop bc
    djnz markera_runt_loop

    ret

analysera:
;avbryter om det r ett skepp eller om markeringen gr ver kanten
    ld a,0
;   cp b
;   ret z
    cp c
    ret z

    ld a,11
;   cp b
;   ret z
    cp c
    ret z

;   ld a,22
;   cp b
;   ret z

    call get_info       ;gr s att hl pekar p rutan bc
    bit 6,(hl)          
    call z,oppna
    ret

oppna:
    push bc
;markerar rutan som ppnad
    set 7,(hl)
;visar att rutan r ppnad
    ld hl,gra_sprite
    call visa_sprite
    pop bc

    ret


;ger kordinaterna (bc) fr rutan som hl pekar p
get_info_bak:
;hl = hur mntte rutan det r
    push hl
    ld de,brade_1
    sbc hl,de

;var tionde ruta ger en ny kollumn
    ld a,l      ;210 rutor, drfr r svaret bara 8 bit
    ld d,10     ;10 rutor o varje kollumn
    ld b,1      ;counter
get_info_bak_loop:
    cp d        ;slutar om det r mindre n 10 kvar
    jp c,get_info_bak_fardig
    sub d       ;tar bort 10 rutor (1 kollumn)
    inc b       ;rknar kollumnerna
    jp get_info_bak_loop

get_info_bak_fardig:
    ld c,a      ;c = hur mnga rutor det r kvar in i den nya kollumnen
    inc c       ;rtt radnummer
    pop hl
    ret

;stter in ett skepp vid kursorn
lagg_in:
    ld bc,(kursor)

;avbryter om rutan r ppnad eller om den redan r ett skepp
    call get_info
    bit 6,(hl)
    jp nz,key_loop
    bit 7,(hl)
    jp nz,key_loop

;om det r frsta delen av ett skepp mste den inte grnsa tlll en annan skeppsdel
    ld a,(har_satt_in)
    cp 0
    jp z,far_satta_in

;upp, mitten
    inc c
    call get_info   ;ger hl fr bc
;man fr stta in om det r ett skepp
    bit 6,(hl)      
    jp nz,far_satta_in

;ner, mitten
    dec c
    dec c
    call get_info
    bit 6,(hl)
    jp nz,far_satta_in

;mitten, vnster
    inc c
    dec b
    call get_info
    bit 6,(hl)
    jp nz,far_satta_in

;mitten, hger
    inc b
    inc b
    call get_info
    bit 6,(hl)
    jp nz,far_satta_in

;annars fr man inte stta in dr...
    jp key_loop

;stter in skeppet
far_satta_in:
    ld bc,(kursor)
    call get_info

;sparar nummern
    ld a,(insatta_skepp)
    ld (hl),a 

;markerar som skepp
    set 6,(hl)

;visar skeppet
    ld bc,(kursor)
    ld hl,skepp_sprite
    call visa_sprite

;kollar om man satt in hela skeppet
    ld hl,skall_satta_in
    ld a,(har_satt_in)
    inc a
    cp (hl)

    jp nz,forts_satt_in

;stter in nsta skepp
    ld a,(insatta_skepp)
    call markera_runt       ;ppnar rutorna runt skeppet
    jp satt_in_nasta        ;stt in nsta skepp

forts_satt_in:
;a blev just kad, men behver bara sparas om inte hela skeppet r utlagt.
    ld (har_satt_in),a

    jp key_loop




;hl=adressen till datan fr rutan dr kursorn r.
get_info:
    push bc
    dec c
    dec b
;a=10*b
    ld a,b
    add a,a     ;*2
    add a,a     ;*4
    add a,a     ;*8
    add a,b     ;*9
    add a,b     ;*10

;a=10*b+c
    add a,c

;adderar a till stller dr matrisen brjar
    ld b,0
    ld c,a
    ld hl,brade_1
    add hl,bc
    pop bc
    ret


;tar bort kursorn frn gamla stllet
fore_flytt:
    ld bc,(kursor)
    push bc
    ld hl,tom_sprite
    call visa_sprite
    pop bc

    ret

;flyttar kursorn t vnster
left:
    push af
    call fore_flytt     ;tar bort gamla kursorn
;kollar s att man inte far utanfr skrmen
    ld a,1
    cp b
    jp z,efter_flytt
    ld a,12
    cp b
    jp z,efter_flytt
;flyttar
    dec b
    jp efter_flytt

right:
    push af
    call fore_flytt

    ld a,10
    cp b
    jp z,efter_flytt
    ld a,21
    cp b
    jp z,efter_flytt

    inc b
    jp efter_flytt

down:
    push af
    call fore_flytt

    ld a,10
    cp c
    jp z,efter_flytt
    inc c
    jp efter_flytt

up:
    push af
    call fore_flytt

    ld a,1
    cp c
    jp z,efter_flytt
    dec c
    jp efter_flytt

;stter ut kurorn p det nya stllet
efter_flytt:
    ld (kursor),bc      ;sparar nya kordinaterna
    call visa_kursor    ;visar skrllet
    pop af
    ret 

;visar kursorn
visa_kursor:
    ld bc,(kursor)
    ld hl,kursor_sprite
    call visa_sprite
    ret

;visar ett 10*10 rutmnster utgnede frn d
visa_rutorna:
    ld hl,tom_sprite        ;tom ruta
    ld b,10         ;counter
start_loop_1:
    push bc
    inc d           ;de istllet fr bc, nsta kollumn
    ld e,0
    ld b,10         ;ny counter
start_loop_2:
    push bc
    inc e           ;nsta rad
    push de
    push hl 
    ld b,d          ;ld bc,de
    ld c,e
    call visa_sprite
    pop hl
    pop de
    pop bc
    djnz start_loop_2
    
    pop bc
    djnz start_loop_1
    ret


;visar spriten
visa_sprite:
;kollar med kanten
    ld a,b
    cp 0
    ret z
    cp 11
    ret z
    cp 22
    ret z
;b=5*b
;   ld a,b      ;redan fixat
    add a,a
    add a,a
    add a,b
    ld b,a

    ld a,c
;kollar
    cp 0
    ret z
    cp 11
    ret z
;raknar
    add a,a
    add a,a
    add a,c
    ld c,a

;visar spriten, inte alkoholen :-)
    jp PutSprite;Clip
;   ret
    
;=========================================================================
; Sprite routines by David Phillips <david@acz.org>    http://www.acz.org/
;=========================================================================
; All sprites are 8x8 masked sprites
;
;   PutSprite      -- black/white                 (sprite, mask)
;
; in:   hl = pointer to sprite, bc = x,y location
; out:  af, bc, de, hl, ix = trash
; size: 250 bytes
;=========================================================================

VideoDraw = $fc00                   ; [1024] virtual screen or video ram

;GrayDraw1 = GrayMem1               ; [1024] dark grayscale plane
;GrayDraw2 = GrayMem2               ; [1024] light grayscale plane
;=========================================================================

; in: hl = 8x8 masked sprite, bc = x,y location
PutSprite:
 push hl                            ; push sprite pointer
 pop ix                             ; pop in ix

; call FindAddress                  ; calc address and offset
; in: bc = x,y location
; out: hl = offset of byte, c = offset in video byte
FindAddress:
 ld a,c                             ; get the y coord
 add a,a                            ; multiply by 2
 add a,a                            ; again by 4
 ld l,a                             ; save as low byte
 ld h,0                             ; clear high byte
 add hl,hl                          ; multiply by 8
 add hl,hl                          ; and again by 16
 ld a,b                             ; now get the x coord
 and %11111000                      ; clear lower 3 bits
 rra                                ; divide by 2
 rra                                ; this time by 4
 rra                                ; and finally by 8
 or l                               ; combine with low byte
 ld l,a                             ; save it
 ld a,b                             ; get x coord again
 and %00000111                      ; clear all but last 3 bits
 ld c,a                             ; save sprite offset in c
 ;ret                               ; return to caller


PutSpriteE:
 ld de,VideoDraw                    ; draw sprite to video memory
 add hl,de                          ; add offset to buffer start
; jr RenderSprite                   ; actually draw the sprite

; in: hl = address in buffer, c = offset, ix = sprite
RenderSprite:
_@RenderSpriteCV =$+1
 ld b,8                             ; set row counter to 8 bytes
RenderSpriteL:
 push bc                            ; save row counter and sprite offset
 ld a,(ix+8)                        ; load mask for this row
_@RenderSpriteM =$-1
 cpl                                ; invert the mask
 ld b,a                             ; save inverted mask
 ld d,(ix)                          ; load sprite byte for this row
 inc ix                             ; advance sprite pointer
 ld a,c                             ; set shift counter to sprite offset
 ld c,$ff                           ; set all bits of right mask byte
 ld e,0                             ; clear right byte of sprite
 or a                               ; is the sprite aligned?
 jr z,RenderSpriteD                 ; then skip shifting it

RenderSpriteS:
 srl d                              ; shift left sprite byte
 rr e                               ; into the right sprite byte
 scf                                ; set carry
 rr b                               ; shift left mask byte
 rr c                               ; into the right mask byte
 dec a                              ; decrease shift counter
 jr nz,RenderSpriteS                ; loop until counter is 0
RenderSpriteD:
_@RenderSpriteCL =$
 ld a,b                             ; load the left sprite byte
 and (hl)                           ; and it with the screen
 or d                               ; or it with the mask
 ld (hl),a                          ; set screen memory to left byte
 inc hl                             ; increase screen pointer
_@RenderSpriteCR =$
 ld a,c                             ; load the right sprite byte
 and (hl)                           ; and it with the screen
 or e                               ; or it with the mask
 ld (hl),a                          ; set screen memory to left byte
 ld de,15                           ; next row is 15 bytes ahead
 add hl,de                          ; move screen pointer to next row
 pop bc                             ; restore loop counter and shift mask
 djnz RenderSpriteL                 ; loop for all bytes in sprite
 ret                                ; done drawing the sprite
 
add_t:
    .text "# of squares: " 



tom_sprite:     ;svart rutan, invers i mitten. terstller efter kursorn.
    .db %11111100
    .db %10000100
    .db %10000100
    .db %10000100
    .db %10000100
    .db %11111100
    .db %00000000
    .db %00000000
    .db %11111100
    .db %10000100
    .db %10000100
    .db %10000100
    .db %10000100
    .db %11111100
    .db %00000000
    .db %00000000

gra_sprite:     ;transparent ram, svartvitt schackmnster i mitten
    .db %00000000
    .db %01010000
    .db %00101000
    .db %01010000
    .db %00101000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %01111000
    .db %01111000
    .db %01111000
    .db %01111000
    .db %00000000
    .db %00000000
    .db %00000000

skepp_sprite:   ;transparent ram, liten svart ruta i mitten
    .db %00000000
    .db %00000000
    .db %00110000
    .db %00110000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %01111000
    .db %01111000
    .db %01111000
    .db %01111000
    .db %00000000
    .db %00000000
    .db %00000000

kursor_sprite:  ;vit ram, transparent i mitten
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %11111100
    .db %10000100
    .db %10000100
    .db %10000100
    .db %10000100
    .db %11111100
    .db %00000000
    .db %00000000

skepp_att_satta_in:
    .db 4,3,3,2,2,2,1,1,1,1,0,4,3,3,2,2,2,1,1,1,1,0

skepp_att_sanka:
    .db 10





.end
